diff -Naur openssl-1.0.0q.orig/crypto/mdc2/mdc2_one.c openssl-1.0.0q/crypto/mdc2/mdc2_one.c
--- openssl-1.0.0q.orig/crypto/mdc2/mdc2_one.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/mdc2/mdc2_one.c	2017-04-25 16:23:40.468619612 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/mdc2.h>
 
diff -Naur openssl-1.0.0q.orig/crypto/mdc2/mdc2dgst.c openssl-1.0.0q/crypto/mdc2/mdc2dgst.c
--- openssl-1.0.0q.orig/crypto/mdc2/mdc2dgst.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/mdc2/mdc2dgst.c	2017-04-25 16:23:40.469620298 +0200
@@ -56,9 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/des.h>
 #include <openssl/mdc2.h>
 
@@ -79,8 +81,8 @@
 	{
 	c->num=0;
 	c->pad_type=1;
-	memset(&(c->h[0]),0x52,MDC2_BLOCK);
-	memset(&(c->hh[0]),0x25,MDC2_BLOCK);
+	op_memset(&(c->h[0]),0x52,MDC2_BLOCK);
+	op_memset(&(c->hh[0]),0x25,MDC2_BLOCK);
 	return 1;
 	}
 
@@ -94,7 +96,7 @@
 		if (i+len < MDC2_BLOCK)
 			{
 			/* partial block */
-			memcpy(&(c->data[i]),in,len);
+			op_memcpy(&(c->data[i]),in,len);
 			c->num+=(int)len;
 			return 1;
 			}
@@ -102,7 +104,7 @@
 			{
 			/* filled one */
 			j=MDC2_BLOCK-i;
-			memcpy(&(c->data[i]),in,j);
+			op_memcpy(&(c->data[i]),in,j);
 			len-=j;
 			in+=j;
 			c->num=0;
@@ -114,7 +116,7 @@
 	j=len-i;
 	if (j > 0)
 		{
-		memcpy(&(c->data[0]),&(in[i]),j);
+		op_memcpy(&(c->data[0]),&(in[i]),j);
 		c->num=(int)j;
 		}
 	return 1;
@@ -169,11 +171,11 @@
 		{
 		if (j == 2)
 			c->data[i++]=0x80;
-		memset(&(c->data[i]),0,MDC2_BLOCK-i);
+		op_memset(&(c->data[i]),0,MDC2_BLOCK-i);
 		mdc2_body(c,c->data,MDC2_BLOCK);
 		}
-	memcpy(md,(char *)c->h,MDC2_BLOCK);
-	memcpy(&(md[MDC2_BLOCK]),(char *)c->hh,MDC2_BLOCK);
+	op_memcpy(md,(char *)c->h,MDC2_BLOCK);
+	op_memcpy(&(md[MDC2_BLOCK]),(char *)c->hh,MDC2_BLOCK);
 	return 1;
 	}
 
diff -Naur openssl-1.0.0q.orig/crypto/mdc2/mdc2test.c openssl-1.0.0q/crypto/mdc2/mdc2test.c
--- openssl-1.0.0q.orig/crypto/mdc2/mdc2test.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/mdc2/mdc2test.c	2017-04-25 16:23:40.470620146 +0200
@@ -56,9 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include "../e_os.h"
 
@@ -107,7 +109,7 @@
 	EVP_DigestUpdate(&c,(unsigned char *)text,strlen(text));
 	EVP_DigestFinal_ex(&c,&(md[0]),NULL);
 
-	if (memcmp(md,pad1,MDC2_DIGEST_LENGTH) != 0)
+	if (op_memcmp(md,pad1,MDC2_DIGEST_LENGTH) != 0)
 		{
 		for (i=0; i<MDC2_DIGEST_LENGTH; i++)
 			printf("%02X",md[i]);
@@ -126,7 +128,7 @@
 	EVP_DigestUpdate(&c,(unsigned char *)text,strlen(text));
 	EVP_DigestFinal_ex(&c,&(md[0]),NULL);
 
-	if (memcmp(md,pad2,MDC2_DIGEST_LENGTH) != 0)
+	if (op_memcmp(md,pad2,MDC2_DIGEST_LENGTH) != 0)
 		{
 		for (i=0; i<MDC2_DIGEST_LENGTH; i++)
 			printf("%02X",md[i]);
diff -Naur openssl-1.0.0q.orig/crypto/mem.c openssl-1.0.0q/crypto/mem.c
--- openssl-1.0.0q.orig/crypto/mem.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/mem.c	2017-04-25 16:23:40.471620273 +0200
@@ -56,12 +56,19 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
-#include <openssl/crypto.h>
-#include "cryptlib.h"
-
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 
+#ifndef OPERA_SMALL_VERSION
+#ifdef _NO_GLOBALS_
+extern int *g_allow_customize_addr();
+#define allow_customize (*g_allow_customize_addr())
+extern int *g_allow_customize_debug_addr();
+#define allow_customize_debug (*g_allow_customize_debug_addr())
+#else
 static int allow_customize = 1;      /* we provide flexible functions for */
 static int allow_customize_debug = 1;/* exchanging memory-related functions at
                                       * run-time, but this must be done
@@ -70,33 +77,46 @@
                                       * problems when malloc/free pairs
                                       * don't match etc. */
 
+#endif
+#endif /* OPERA_SMALL_VERSION */
 
 
 /* the following pointers may be changed as long as 'allow_customize' is set */
 
-static void *(*malloc_func)(size_t)         = malloc;
+#ifdef OPERA_SMALL_VERSION
+#define malloc_func		op_malloc
+#define malloc_ex_func(s, f, l)	op_malloc(s)
+#define realloc_func	op_realloc
+#define realloc_ex_func(p, s, f, l)		op_realloc(p,s)
+#define free_func		op_free
+#define free_locked_func	op_free
+#else
+
+static void *(*malloc_func)(size_t)         = op_malloc;
 static void *default_malloc_ex(size_t num, const char *file, int line)
 	{ return malloc_func(num); }
 static void *(*malloc_ex_func)(size_t, const char *file, int line)
         = default_malloc_ex;
 
-static void *(*realloc_func)(void *, size_t)= realloc;
+static void *(*realloc_func)(void *, size_t)= op_realloc;
 static void *default_realloc_ex(void *str, size_t num,
         const char *file, int line)
 	{ return realloc_func(str,num); }
 static void *(*realloc_ex_func)(void *, size_t, const char *file, int line)
         = default_realloc_ex;
 
-static void (*free_func)(void *)            = free;
+static void (*free_func)(void *)            = op_free;
 
-static void *(*malloc_locked_func)(size_t)  = malloc;
+#ifndef OPERA_SMALL_VERSION
+static void *(*malloc_locked_func)(size_t)  = op_malloc;
 static void *default_malloc_locked_ex(size_t num, const char *file, int line)
 	{ return malloc_locked_func(num); }
 static void *(*malloc_locked_ex_func)(size_t, const char *file, int line)
         = default_malloc_locked_ex;
+#endif
 
-static void (*free_locked_func)(void *)     = free;
-
+static void (*free_locked_func)(void *)     = op_free;
+#endif
 
 
 /* may be changed as long as 'allow_customize_debug' is set */
@@ -113,15 +133,23 @@
 #else
 /* applications can use CRYPTO_malloc_debug_init() to select above case
  * at run-time */
+#ifndef OPERA_SMALL_VERSION
+#ifndef _NO_GLOBALS_
 static void (*malloc_debug_func)(void *,int,const char *,int,int) = NULL;
 static void (*realloc_debug_func)(void *,void *,int,const char *,int,int)
 	= NULL;
 static void (*free_debug_func)(void *,int) = NULL;
+#ifndef OPERA_SMALL_VERSION
 static void (*set_debug_options_func)(long) = NULL;
 static long (*get_debug_options_func)(void) = NULL;
 #endif
+#endif
+#endif /* OPERA_SMALL_VERSION */
+#endif
 
 
+#ifndef OPERA_SMALL_VERSION
+#ifndef _NO_GLOBALS_
 int CRYPTO_set_mem_functions(void *(*m)(size_t), void *(*r)(void *, size_t),
 	void (*f)(void *))
 	{
@@ -164,6 +192,7 @@
 	free_locked_func=f;
 	return 1;
 	}
+#endif
 
 int CRYPTO_set_locked_mem_ex_functions(
         void *(*m)(size_t,const char *,int),
@@ -178,6 +207,8 @@
 	return 1;
 	}
 
+
+#ifndef _NO_GLOBALS_
 int CRYPTO_set_mem_debug_functions(void (*m)(void *,int,const char *,int,int),
 				   void (*r)(void *,void *,int,const char *,int,int),
 				   void (*f)(void *,int),
@@ -193,6 +224,7 @@
 	get_debug_options_func=go;
 	return 1;
 	}
+#endif
 
 
 void CRYPTO_get_mem_functions(void *(**m)(size_t), void *(**r)(void *, size_t),
@@ -233,6 +265,7 @@
 	if (f != NULL) *f=free_locked_func;
 	}
 
+#ifndef _NO_GLOBALS_
 void CRYPTO_get_mem_debug_functions(void (**m)(void *,int,const char *,int,int),
 				    void (**r)(void *,void *,int,const char *,int,int),
 				    void (**f)(void *,int),
@@ -245,8 +278,11 @@
 	if (so != NULL) *so=set_debug_options_func;
 	if (go != NULL) *go=get_debug_options_func;
 	}
+#endif
+#endif
 
 
+#ifndef OPERA_SMALL_VERSION
 void *CRYPTO_malloc_locked(int num, const char *file, int line)
 	{
 	void *ret = NULL;
@@ -254,17 +290,21 @@
 	if (num <= 0) return NULL;
 
 	allow_customize = 0;
+#ifndef _NO_GLOBALS_
 	if (malloc_debug_func != NULL)
 		{
 		allow_customize_debug = 0;
 		malloc_debug_func(NULL, num, file, line, 0);
 		}
+#endif
 	ret = malloc_locked_ex_func(num,file,line);
 #ifdef LEVITTE_DEBUG_MEM
 	fprintf(stderr, "LEVITTE_DEBUG_MEM:         > 0x%p (%d)\n", ret, num);
 #endif
+#ifndef _NO_GLOBALS_
 	if (malloc_debug_func != NULL)
 		malloc_debug_func(ret, num, file, line, 1);
+#endif
 
 #ifndef OPENSSL_CPUID_OBJ
         /* Create a dependency on the value of 'cleanse_ctr' so our memory
@@ -290,6 +330,7 @@
 	if (free_debug_func != NULL)
 		free_debug_func(NULL, 1);
 	}
+#endif // !OPERA_SMALL_VERSION
 
 void *CRYPTO_malloc(int num, const char *file, int line)
 	{
@@ -297,13 +338,19 @@
 
 	if (num <= 0) return NULL;
 
+#ifndef OPERA_SMALL_VERSION
+#ifndef _NO_GLOBALS_
 	allow_customize = 0;
 	if (malloc_debug_func != NULL)
 		{
 		allow_customize_debug = 0;
 		malloc_debug_func(NULL, num, file, line, 0);
 		}
+#endif // !_NO_GLOBALS_
+#endif // !OPERA_SMALL_VERSION
 	ret = malloc_ex_func(num,file,line);
+#ifndef OPERA_SMALL_VERSION
+#ifndef _NO_GLOBALS_
 #ifdef LEVITTE_DEBUG_MEM
 	fprintf(stderr, "LEVITTE_DEBUG_MEM:         > 0x%p (%d)\n", ret, num);
 #endif
@@ -319,14 +366,16 @@
                 ((unsigned char *)ret)[0] = cleanse_ctr;
 	}
 #endif
+#endif // !_NO_GLOBALS_
+#endif // !OPERA_SMALL_VERSION
 
 	return ret;
 	}
 char *CRYPTO_strdup(const char *str, const char *file, int line)
 	{
-	char *ret = CRYPTO_malloc(strlen(str)+1, file, line);
+	char *ret = (char *)CRYPTO_malloc(op_strlen(str)+1, file, line);
 
-	strcpy(ret, str);
+	op_strcpy(ret, str);
 	return ret;
 	}
 
@@ -339,14 +388,22 @@
 
 	if (num <= 0) return NULL;
 
+#ifndef OPERA_SMALL_VERSION
+#ifndef _NO_GLOBALS_
 	if (realloc_debug_func != NULL)
 		realloc_debug_func(str, NULL, num, file, line, 0);
+#endif
+#endif
 	ret = realloc_ex_func(str,num,file,line);
 #ifdef LEVITTE_DEBUG_MEM
 	fprintf(stderr, "LEVITTE_DEBUG_MEM:         | 0x%p -> 0x%p (%d)\n", str, ret, num);
 #endif
+#ifndef OPERA_SMALL_VERSION
+#ifndef _NO_GLOBALS_
 	if (realloc_debug_func != NULL)
 		realloc_debug_func(str, ret, num, file, line, 1);
+#endif
+#endif
 
 	return ret;
 	}
@@ -365,12 +422,16 @@
 	 * |old_len| bytes to the new buffer, below. */
 	if (num < old_len) return NULL;
 
+#ifndef OPERA_SMALL_VERSION
+#ifndef _NO_GLOBALS_
 	if (realloc_debug_func != NULL)
 		realloc_debug_func(str, NULL, num, file, line, 0);
+#endif
+#endif
 	ret=malloc_ex_func(num,file,line);
 	if(ret)
 		{
-		memcpy(ret,str,old_len);
+		op_memcpy(ret,str,old_len);
 		OPENSSL_cleanse(str,old_len);
 		free_func(str);
 		}
@@ -379,24 +440,37 @@
 		"LEVITTE_DEBUG_MEM:         | 0x%p -> 0x%p (%d)\n",
 		str, ret, num);
 #endif
+#ifndef OPERA_SMALL_VERSION
+#ifndef _NO_GLOBALS_
 	if (realloc_debug_func != NULL)
 		realloc_debug_func(str, ret, num, file, line, 1);
+#endif
+#endif
 
 	return ret;
 	}
 
 void CRYPTO_free(void *str)
 	{
+#ifndef OPERA_SMALL_VERSION
+#ifndef _NO_GLOBALS_
 	if (free_debug_func != NULL)
 		free_debug_func(str, 0);
+#endif
+#endif
 #ifdef LEVITTE_DEBUG_MEM
 	fprintf(stderr, "LEVITTE_DEBUG_MEM:         < 0x%p\n", str);
 #endif
 	free_func(str);
+#ifndef OPERA_SMALL_VERSION
+#ifndef _NO_GLOBALS_
 	if (free_debug_func != NULL)
 		free_debug_func(NULL, 1);
+#endif
+#endif
 	}
 
+#ifndef OPERA_SMALL_VERSION
 void *CRYPTO_remalloc(void *a, int num, const char *file, int line)
 	{
 	if (a != NULL) OPENSSL_free(a);
@@ -404,15 +478,20 @@
 	return(a);
 	}
 
+#ifndef _NO_GLOBALS_
 void CRYPTO_set_mem_debug_options(long bits)
 	{
 	if (set_debug_options_func != NULL)
 		set_debug_options_func(bits);
 	}
+#endif // !_NO_GLOBALS_
 
+#ifndef _NO_GLOBALS_
 long CRYPTO_get_mem_debug_options(void)
 	{
 	if (get_debug_options_func != NULL)
 		return get_debug_options_func();
 	return 0;
 	}
+#endif // !_NO_GLOBALS_
+#endif // !OPERA_SMALL_VERSION
diff -Naur openssl-1.0.0q.orig/crypto/mem_clr.c openssl-1.0.0q/crypto/mem_clr.c
--- openssl-1.0.0q.orig/crypto/mem_clr.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/mem_clr.c	2017-04-25 16:23:40.472620120 +0200
@@ -56,8 +56,12 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <string.h>
-#include <openssl/crypto.h>
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
+
+#ifndef OPERA_SMALL_VERSION
 
 unsigned char cleanse_ctr = 0;
 
@@ -75,3 +79,5 @@
 		ctr += (63 + (size_t)p);
 	cleanse_ctr = (unsigned char)ctr;
 	}
+
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/mem_dbg.c openssl-1.0.0q/crypto/mem_dbg.c
--- openssl-1.0.0q.orig/crypto/mem_dbg.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/mem_dbg.c	2017-04-25 16:23:40.473619689 +0200
@@ -109,16 +109,27 @@
  *
  */
 
+
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
 #include <time.h>	
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/crypto.h>
 #include <openssl/buffer.h>
 #include <openssl/bio.h>
 #include <openssl/lhash.h>
 
+
+#ifdef _NO_GLOBALS_
+extern int *g_mh_mode_addr();
+#define mh_mode (*g_mh_mode_addr())
+#else
 static int mh_mode=CRYPTO_MEM_CHECK_OFF;
+#endif
 /* The state changes to CRYPTO_MEM_CHECK_ON | CRYPTO_MEM_CHECK_ENABLE
  * when the application asks for it (usually after library initialisation
  * for which no book-keeping is desired).
@@ -133,12 +144,21 @@
  * State CRYPTO_MEM_CHECK_ENABLE without ..._ON makes no sense whatsoever.
  */
 
-static unsigned long order = 0; /* number of memory requests */
+#ifndef OPERA_SMALL_VERSION
+#ifdef _NO_GLOBALS_
+extern unsigned long *g_order_addr();
+#define g_order (*g_order_addr())
+extern LHASH* *g_mh_addr();
+#define mh (*g_mh_addr())
+#else
+static unsigned long g_order = 0; /* number of memory requests */
 
 DECLARE_LHASH_OF(MEM);
 static LHASH_OF(MEM) *mh=NULL; /* hash-table of memory requests
 				* (address as key); access requires
 				* MALLOC2 lock */
+#endif // _NO_GLOBALS_
+#endif // OPERA_SMALL_VERSION
 
 
 typedef struct app_mem_info_st
@@ -160,6 +180,10 @@
 
 static void app_info_free(APP_INFO *);
 
+#ifdef _NO_GLOBALS_
+extern LHASH* *g_amih_addr();
+#define amih (*g_amih_addr())
+#else
 DECLARE_LHASH_OF(APP_INFO);
 static LHASH_OF(APP_INFO) *amih=NULL; /* hash-table with those
 				       * app_mem_info_st's that are at
@@ -167,6 +191,7 @@
 				       * stack (with `thread' as key);
 				       * access requires MALLOC2
 				       * lock */
+#endif // _NO_GLOBALS_
 
 typedef struct mem_st
 /* memory-block description */
@@ -181,6 +206,11 @@
 	APP_INFO *app_info;
 	} MEM;
 
+#ifndef OPERA_SMALL_VERSION
+#ifdef _NO_GLOBALS_
+extern long *g_options_addr();
+#define options (*g_options_addr())
+#else
 static long options =             /* extra information to be recorded */
 #if defined(CRYPTO_MDEBUG_TIME) || defined(CRYPTO_MDEBUG_ALL)
 	V_CRYPTO_MDEBUG_TIME |
@@ -189,8 +219,16 @@
 	V_CRYPTO_MDEBUG_THREAD |
 #endif
 	0;
+#endif
+#endif /* OPERA_SMALL_VERSION */
 
 
+#ifdef _NO_GLOBALS_
+extern unsigned int *g_num_disable_addr();
+#define num_disable (*g_num_disable_addr())
+extern unsigned long *g_disabling_thread_addr();
+#define disabling_thread (*g_disabling_thread_addr())
+#else
 static unsigned int num_disable = 0; /* num_disable > 0
                                       *     iff
                                       * mh_mode == CRYPTO_MEM_CHECK_ON (w/o ..._ENABLE)
@@ -200,6 +238,7 @@
  * case (by the thread named in disabling_thread).
  */
 static CRYPTO_THREADID disabling_threadid;
+#endif // _NO_GLOBALS_
 
 static void app_info_free(APP_INFO *inf)
 	{
@@ -302,6 +341,7 @@
 	}	
 
 
+#ifndef OPERA_SMALL_VERSION
 void CRYPTO_dbg_set_options(long bits)
 	{
 	options = bits;
@@ -336,6 +376,7 @@
 	return(ret);
 	}
 static IMPLEMENT_LHASH_HASH_FN(mem, MEM)
+#endif // OPERA_SMALL_VERSION
 
 /* static int app_info_cmp(APP_INFO *a, APP_INFO *b) */
 static int app_info_cmp(const void *a_void, const void *b_void)
@@ -460,6 +501,7 @@
 	return(ret);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int CRYPTO_remove_all_info(void)
 	{
 	int ret=0;
@@ -477,7 +519,8 @@
 	}
 
 
-static unsigned long break_order_num=0;
+static const unsigned long break_order_num=0;
+
 void CRYPTO_dbg_malloc(void *addr, int num, const char *file, int line,
 	int before_p)
 	{
@@ -522,12 +565,12 @@
 			else
 				memset(&m->threadid, 0, sizeof(m->threadid));
 
-			if (order == break_order_num)
+			if (g_order == break_order_num)
 				{
 				/* BREAK HERE */
-				m->order=order;
+				m->order=g_order;
 				}
-			m->order=order++;
+			m->order=g_order++;
 #ifdef LEVITTE_DEBUG_MEM
 			fprintf(stderr, "LEVITTE_DEBUG_MEM: [%5ld] %c 0x%p (%d)\n",
 				m->order,
@@ -830,7 +873,7 @@
 	if (mh == NULL) return;
 	/* Need to turn off memory checking when allocated BIOs ... especially
 	 * as we're creating them at a time when we're trying to check we've not
-	 * left anything un-free()'d!! */
+	 * left anything un-op_free()'d!! */
 	MemCheck_off();
 	b = BIO_new(BIO_s_file());
 	MemCheck_on();
@@ -872,3 +915,5 @@
 			 &cb);
 	CRYPTO_w_unlock(CRYPTO_LOCK_MALLOC2);
 	}
+
+#endif // OPERA_SMALL_VERSION
diff -Naur openssl-1.0.0q.orig/crypto/modes/cbc128.c openssl-1.0.0q/crypto/modes/cbc128.c
--- openssl-1.0.0q.orig/crypto/modes/cbc128.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/modes/cbc128.c	2017-04-25 16:23:40.475619663 +0200
@@ -49,6 +49,8 @@
  */
 
 #include "modes.h"
+
+#ifndef OPERA_SMALL_VERSION
 #include <string.h>
 
 #ifndef MODES_DEBUG
@@ -57,6 +59,7 @@
 # endif
 #endif
 #include <assert.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #define STRICT_ALIGNMENT 1
 #if defined(__i386) || defined(__i386__) || \
diff -Naur openssl-1.0.0q.orig/crypto/o_str.c openssl-1.0.0q/crypto/o_str.c
--- openssl-1.0.0q.orig/crypto/o_str.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/o_str.c	2017-04-25 16:23:40.477620756 +0200
@@ -56,8 +56,10 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <ctype.h>
-#include <e_os.h>
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/e_os.h>
 #include "o_str.h"
 
 #if !defined(OPENSSL_IMPLEMENTS_strncasecmp) && \
@@ -71,7 +73,7 @@
 #if defined(OPENSSL_IMPLEMENTS_strncasecmp)
 	while (*str1 && *str2 && n)
 		{
-		int res = toupper(*str1) - toupper(*str2);
+		int res = op_toupper(*str1) - op_toupper(*str2);
 		if (res) return res < 0 ? -1 : 1;
 		str1++;
 		str2++;
diff -Naur openssl-1.0.0q.orig/crypto/o_str.h openssl-1.0.0q/crypto/o_str.h
--- openssl-1.0.0q.orig/crypto/o_str.h	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/o_str.h	2017-04-25 16:23:40.478620045 +0200
@@ -59,10 +59,11 @@
 #ifndef HEADER_O_STR_H
 #define HEADER_O_STR_H
 
+#ifndef OPERA_SMALL_VERSION
 #include <stddef.h>		/* to get size_t */
+#endif /* !OPERA_SMALL_VERSION */
 
 int OPENSSL_strcasecmp(const char *str1, const char *str2);
 int OPENSSL_strncasecmp(const char *str1, const char *str2, size_t n);
-int OPENSSL_memcmp(const void *p1,const void *p2,size_t n);
 
 #endif
diff -Naur openssl-1.0.0q.orig/crypto/o_time.c openssl-1.0.0q/crypto/o_time.c
--- openssl-1.0.0q.orig/crypto/o_time.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/o_time.c	2017-04-25 16:23:40.480619182 +0200
@@ -60,7 +60,9 @@
  */
 
 #include <openssl/e_os2.h>
+#ifndef OPERA_SMALL_VERSION
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "o_time.h"
 
 #ifdef OPENSSL_SYS_VMS
@@ -69,12 +71,14 @@
 #  define VMS_GMTIME_OK
 # endif
 # ifndef VMS_GMTIME_OK
+#ifndef OPERA_SMALL_VERSION
 #  include <libdtdef.h>
 #  include <lib$routines.h>
 #  include <lnmdef.h>
 #  include <starlet.h>
 #  include <descrip.h>
 #  include <stdlib.h>
+#endif /* !OPERA_SMALL_VERSION */
 # endif /* ndef VMS_GMTIME_OK */
 #endif
 
@@ -92,7 +96,7 @@
 	if (ts == NULL)
 		return NULL;
 
-	memcpy(result, ts, sizeof(struct tm));
+	op_memcpy(result, ts, sizeof(struct tm));
 	ts = result;
 #endif
 #if defined( OPENSSL_SYS_VMS) && !defined( VMS_GMTIME_OK)
@@ -100,7 +104,7 @@
 		{
 		static $DESCRIPTOR(tabnam,"LNM$DCL_LOGICAL");
 		static $DESCRIPTOR(lognam,"SYS$TIMEZONE_DIFFERENTIAL");
-		char logvalue[256];
+		char logvalue[256];  	/* ARRAY OK UNUSED 2009-05-25 yngve VMS ONLY*/
 		unsigned int reslen = 0;
 		struct {
 			short buflen;
@@ -133,11 +137,11 @@
 **  the other __utc_* deals with time in terms of UTC.
 */
 /* We use the same conditions as in said time.h to check if we should
-   assume that t contains local time (and should therefore be adjusted)
+   assume that t contains local op_time (and should therefore be adjusted)
    or UTC (and should therefore be left untouched). */
 #if __CRTL_VER < 70000000 || defined _VMS_V6_SOURCE
 		/* Get the numerical value of the equivalence string */
-		status = atoi(logvalue);
+		status = op_atoi(logvalue);
 
 		/* and use it to move time to GMT */
 		t -= status;
diff -Naur openssl-1.0.0q.orig/crypto/o_time.h openssl-1.0.0q/crypto/o_time.h
--- openssl-1.0.0q.orig/crypto/o_time.h	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/o_time.h	2017-04-25 16:23:40.483620401 +0200
@@ -59,7 +59,9 @@
 #ifndef HEADER_O_TIME_H
 #define HEADER_O_TIME_H
 
+#ifndef OPERA_SMALL_VERSION
 #include <time.h>
+#endif // OPERA_SMALL_VERSION
 
 struct tm *OPENSSL_gmtime(const time_t *timer, struct tm *result);
 int OPENSSL_gmtime_adj(struct tm *tm, int offset_day, long offset_sec);
diff -Naur openssl-1.0.0q.orig/crypto/objects/.gitignore openssl-1.0.0q/crypto/objects/.gitignore
--- openssl-1.0.0q.orig/crypto/objects/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/objects/.gitignore	2017-04-25 16:23:40.483620401 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/objects/o_names.c openssl-1.0.0q/crypto/objects/o_names.c
--- openssl-1.0.0q.orig/crypto/objects/o_names.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/objects/o_names.c	2017-04-25 16:23:40.484620528 +0200
@@ -1,7 +1,10 @@
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 
+#include <openssl/cryptlib.h>
 #include <openssl/err.h>
 #include <openssl/lhash.h>
 #include <openssl/objects.h>
@@ -23,8 +26,16 @@
  * that applications may define.  I only really use the free function field.
  */
 DECLARE_LHASH_OF(OBJ_NAME);
+#ifdef OPERA_SMALL_VERSION
+OPENSSL_IMPLEMENT_GLOBAL(LHASH_OF(OBJ_NAME) *, names_lh);
+#define names_lh OPENSSL_GLOBAL_REF(names_lh)
+#else
 static LHASH_OF(OBJ_NAME) *names_lh=NULL;
+#endif // OPERA_SMALL_VERSION
+
+#ifndef OPERA_SMALL_VERSION
 static int names_type_num=OBJ_NAME_TYPE_NUM;
+#endif // !OPERA_SMALL_VERSION
 
 typedef struct name_funcs_st
 	{
@@ -36,7 +47,12 @@
 DECLARE_STACK_OF(NAME_FUNCS)
 IMPLEMENT_STACK_OF(NAME_FUNCS)
 
+#ifdef OPERA_SMALL_VERSION
+OPENSSL_IMPLEMENT_GLOBAL(STACK_OF(NAME_FUNCS) *, name_funcs_stack);
+#define name_funcs_stack OPENSSL_GLOBAL_REF(name_funcs_stack)
+#else
 static STACK_OF(NAME_FUNCS) *name_funcs_stack;
+#endif
 
 /* The LHASH callbacks now use the raw "void *" prototypes and do per-variable
  * casting in the functions. This prevents function pointer casting without the
@@ -59,6 +75,7 @@
 	return(names_lh != NULL);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int OBJ_NAME_new_index(unsigned long (*hash_func)(const char *),
 	int (*cmp_func)(const char *, const char *),
 	void (*free_func)(const char *, int, const char *))
@@ -110,6 +127,7 @@
 		name_funcs->free_func = free_func;
 	return(ret);
 	}
+#endif
 
 /* static int obj_name_cmp(OBJ_NAME *a, OBJ_NAME *b) */
 static int obj_name_cmp(const void *a_void, const void *b_void)
@@ -128,7 +146,7 @@
 				a->type)->cmp_func(a->name,b->name);
 			}
 		else
-			ret=strcmp(a->name,b->name);
+			ret=op_strcmp(a->name,b->name);
 		}
 	return(ret);
 	}
@@ -295,7 +313,7 @@
 
 static void do_all_sorted_fn(const OBJ_NAME *name,void *d_)
 	{
-	struct doall_sorted *d=d_;
+	struct doall_sorted *d=(struct doall_sorted *)d_;
 
 	if(name->type != d->type)
 		return;
@@ -305,10 +323,10 @@
 
 static int do_all_sorted_cmp(const void *n1_,const void *n2_)
 	{
-	const OBJ_NAME * const *n1=n1_;
-	const OBJ_NAME * const *n2=n2_;
+	const OBJ_NAME * const *n1=(const OBJ_NAME * const *)n1_;
+	const OBJ_NAME * const *n2=(const OBJ_NAME * const *)n2_;
 
-	return strcmp((*n1)->name,(*n2)->name);
+	return op_strcmp((*n1)->name,(*n2)->name);
 	}
 
 void OBJ_NAME_do_all_sorted(int type,void (*fn)(const OBJ_NAME *,void *arg),
@@ -318,11 +336,11 @@
 	int n;
 
 	d.type=type;
-	d.names=OPENSSL_malloc(lh_OBJ_NAME_num_items(names_lh)*sizeof *d.names);
+	d.names=(const OBJ_NAME **)OPENSSL_malloc(lh_OBJ_NAME_num_items(names_lh)*sizeof *d.names);
 	d.n=0;
 	OBJ_NAME_do_all(type,do_all_sorted_fn,&d);
 
-	qsort((void *)d.names,d.n,sizeof *d.names,do_all_sorted_cmp);
+	op_qsort((void *)d.names,d.n,sizeof *d.names,do_all_sorted_cmp);
 
 	for(n=0 ; n < d.n ; ++n)
 		fn(d.names[n],arg);
@@ -330,7 +348,12 @@
 	OPENSSL_free((void *)d.names);
 	}
 
-static int free_type;
+#ifdef OPERA_SMALL_VERSION
+OPENSSL_IMPLEMENT_GLOBAL(int, free_type);
+#define free_type OPENSSL_GLOBAL_REF(free_type)
+#else
+static int free_type=0;
+#endif
 
 static void names_lh_free_doall(OBJ_NAME *onp)
 	{
diff -Naur openssl-1.0.0q.orig/crypto/objects/obj_dat.bat openssl-1.0.0q/crypto/objects/obj_dat.bat
--- openssl-1.0.0q.orig/crypto/objects/obj_dat.bat	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/objects/obj_dat.bat	2017-04-25 16:23:40.485621214 +0200
@@ -0,0 +1 @@
+perl obj_dat.pl obj_mac.h obj_dat.h
